Lattice Grid Buy a licence

demo D153

Moving rows between grids

Drag a row out of one grid and into another

rowTransfer: { group }

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/lattice-grid.min.css">
<style>
  #catalogue > div, #basket > div { height: 460px; }
</style>
<div id="app"></div>

<script type="module">
  import * as Vue from 'https://esm.sh/vue@3';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/modules/vue.esm.min.js';

  const LatticeGrid = createLatticeGrid({ vue: Vue, createGrid });

  // The same columns for both grids.
  const columns = [
    { field: 'circuit', title: 'Circuit', layout: { width: 190 } },
    { field: 'region', title: 'Region' },
    { field: 'status', title: 'Status', filter: { type: 'set' } },
  ];

  Vue.createApp({
    components: { LatticeGrid },
    data() {
      return {
        // The catalogue sends rows and reorders its own; group ties the two grids
        // together so a row can be dragged from one into the other.
        catalogue: {
          rowKey: 'id', columns, rows,  // the available circuits
          rowReorder: true,
          rowTransfer: { receive: false, group: 'circuits' },
        },
        // The basket starts empty and only receives.
        basket: {
          rowKey: 'id', columns, rows: [],
          rowTransfer: { send: false, group: 'circuits' },
        },
      };
    },
    template: `
      <div style="display: flex; gap: 12px">
        <div id="catalogue" style="flex: 1; min-width: 0"><lattice-grid v-bind="catalogue" /></div>
        <div id="basket" style="flex: 1; min-width: 0"><lattice-grid v-bind="basket" /></div>
      </div>
    `,
  }).mount('#app');
</script>

Dragging rows between two grids

Row transfer moves a row out of one grid and into another by dragging it across, the way a catalogue row is dragged into a basket. A developer reaches for this whenever a task is about moving records between two lists: building an order from a product catalogue, assigning people from a pool into teams, filing items from an inbox into folders. Lattice Grid links the grids with rowTransfer: { group }, giving both grids the same group name so a row picked up in one is accepted by the other; the source grid emits the removed row and the target grid emits the received one, so both data models stay in step. As a JavaScript data grid, each grid virtualises its own body independently, so a catalogue of many thousands of rows and a short basket both stay responsive during the drag, and only the dragged row element travels between them. The drag target shows a clear insertion point, and the transfer is available from the keyboard through cut and paste between the two grids, so the workflow does not depend on a pointer and reaches keyboard and screen reader users.

How do I drag rows from one data grid into another?

Give both grids the same rowTransfer: { group } name. A row dragged out of one grid is then accepted by the other; the source grid emits the removed row and the target emits the received row, keeping both data models in sync. The same transfer works from the keyboard through cut and paste between the two grids.

Lattice Grid Buy a licence

demo D153

Moving rows between grids

Drag a row out of one grid and into another

rowTransfer: { group }

Building…
Loading a live grid…

The configuration

import * as ng from '@angular/core';
import { Component } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { createGrid } from '@toclocoinc/lattice-grid';
import '@toclocoinc/lattice-grid/css';
import createLatticeGrid from '@toclocoinc/lattice-grid/modules/angular';

const { LatticeGridComponent } = createLatticeGrid({ ng, createGrid });

const columns = [
  { field: 'circuit', title: 'Circuit', layout: { width: 190 } },
  { field: 'region', title: 'Region' },
  { field: 'status', title: 'Status', filter: { type: 'set' } },
];

// Two grids in one group: drag a row out of the catalogue and it lands in the
// basket. The catalogue reorders its own and only sends; the basket starts empty
// and only receives.
@Component({
  selector: 'app-root',
  standalone: true,
  imports: [LatticeGridComponent],
  template:
    '<div style="display:flex;gap:12px;height:460px">' +
    '  <lattice-grid [config]="catalogue" style="flex:1;min-width:0"></lattice-grid>' +
    '  <lattice-grid [config]="basket" style="flex:1;min-width:0"></lattice-grid>' +
    '</div>',
})
export class AppComponent {
  catalogue = {
    rowKey: 'id',
    columns,
    rows: [/* the available circuits */],
    rowReorder: true,
    rowTransfer: { receive: false, group: 'circuits' },
  };
  basket = {
    rowKey: 'id',
    columns,
    rows: [],
    rowTransfer: { send: false, group: 'circuits' },
  };
}

bootstrapApplication(AppComponent);

Dragging rows between two grids

Row transfer moves a row out of one grid and into another by dragging it across, the way a catalogue row is dragged into a basket. A developer reaches for this whenever a task is about moving records between two lists: building an order from a product catalogue, assigning people from a pool into teams, filing items from an inbox into folders. Lattice Grid links the grids with rowTransfer: { group }, giving both grids the same group name so a row picked up in one is accepted by the other; the source grid emits the removed row and the target grid emits the received one, so both data models stay in step. As a JavaScript data grid, each grid virtualises its own body independently, so a catalogue of many thousands of rows and a short basket both stay responsive during the drag, and only the dragged row element travels between them. The drag target shows a clear insertion point, and the transfer is available from the keyboard through cut and paste between the two grids, so the workflow does not depend on a pointer and reaches keyboard and screen reader users.

How do I drag rows from one data grid into another?

Give both grids the same rowTransfer: { group } name. A row dragged out of one grid is then accepted by the other; the source grid emits the removed row and the target emits the received row, keeping both data models in sync. The same transfer works from the keyboard through cut and paste between the two grids.

Lattice Grid Buy a licence

demo D153

Moving rows between grids

Drag a row out of one grid and into another

rowTransfer: { group }

Building…
Loading a live grid…

The configuration

<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/lattice-grid.min.css">

<div id="app"></div>

<script type="module">
  import React from 'https://esm.sh/react@18';
  import { createRoot } from 'https://esm.sh/react-dom@18/client';
  import { createGrid } from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/lattice-grid.esm.min.js';
  import createLatticeGrid from 'https://cdn.jsdelivr.net/npm/@toclocoinc/lattice-grid@1.28.0/modules/react.esm.min.js';

  const LatticeGrid = createLatticeGrid({ React, createGrid });

  const columns = [
    { field: 'circuit', title: 'Circuit', layout: { width: 190 } },
    { field: 'region', title: 'Region' },
    { field: 'status', title: 'Status', filter: { type: 'set' } },
  ];

  const rows = [/* the available circuits */];

  function App() {
    // Two grids in one group: drag a row out of the catalogue and it lands in
    // the basket. The catalogue reorders its own and only sends; the basket
    // starts empty and only receives.
    return (
      <div style={{ display: 'flex', gap: '12px', height: '460px' }}>
        <LatticeGrid
          rowKey="id"
          columns={columns}
          rows={rows}
          rowReorder
          rowTransfer={{ receive: false, group: 'circuits' }}
          style={{ flex: 1, minWidth: 0 }}
        />
        <LatticeGrid
          rowKey="id"
          columns={columns}
          rows={[]}
          rowTransfer={{ send: false, group: 'circuits' }}
          style={{ flex: 1, minWidth: 0 }}
        />
      </div>
    );
  }

  createRoot(document.getElementById('app')).render(<App />);
</script>

Dragging rows between two grids

Row transfer moves a row out of one grid and into another by dragging it across, the way a catalogue row is dragged into a basket. A developer reaches for this whenever a task is about moving records between two lists: building an order from a product catalogue, assigning people from a pool into teams, filing items from an inbox into folders. Lattice Grid links the grids with rowTransfer: { group }, giving both grids the same group name so a row picked up in one is accepted by the other; the source grid emits the removed row and the target grid emits the received one, so both data models stay in step. As a JavaScript data grid, each grid virtualises its own body independently, so a catalogue of many thousands of rows and a short basket both stay responsive during the drag, and only the dragged row element travels between them. The drag target shows a clear insertion point, and the transfer is available from the keyboard through cut and paste between the two grids, so the workflow does not depend on a pointer and reaches keyboard and screen reader users.

How do I drag rows from one data grid into another?

Give both grids the same rowTransfer: { group } name. A row dragged out of one grid is then accepted by the other; the source grid emits the removed row and the target emits the received row, keeping both data models in sync. The same transfer works from the keyboard through cut and paste between the two grids.